<?php
#-------------------------------------------------------------------------------
/** @author Alex Keda, for vps-server.pro */
#-------------------------------------------------------------------------------
if(Is_Error(System_Load('libs/HTTP.php','classes/Net_IDNA.class.php')))
	return ERROR | @Trigger_Error(500);
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
function VmManager5_OVZ_Logon($Settings,$Params){
	/****************************************************************************/
	$__args_types = Array('array','array');
	#-----------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/****************************************************************************/
	return Array('Url'=>$Settings['Params']['Url'],'Args'=>Array('lang'=>$Settings['Params']['Language'],'theme'=>$Settings['Params']['Theme'],'checkcookie'=>'no','username'=>$Params['Login'],'password'=>$Params['Password'],'func'=>'auth'));
	#-------------------------------------------------------------------------------
}

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
function VmManager5_OVZ_Create($Settings,$VPSOrder,$IP,$VPSScheme){
	/******************************************************************************/
	$__args_types = Array('array','array','string','array');
	#-------------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/******************************************************************************/
	$IDNA = new Net_IDNA();
	#-------------------------------------------------------------------------------
	$Domain = $IDNA->encode($VPSOrder['Domain']);
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	# проверяем наличие такого юзера
	$Request = Array('func'=>'user.edit','elid'=>$VPSOrder['Login']);
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request);
	#-------------------------------------------------------------------------------
	$Doc = $XML['doc'];
	#-------------------------------------------------------------------------------
	if(!IsSet($Doc['error'])){
		#-------------------------------------------------------------------------------
		Debug(SPrintF('[VmManager5_OVZ_Create]: юзер %s найден, проверяем его виртуалки',$VPSOrder['Login']));
		#-------------------------------------------------------------------------------
		# ошибки нет, юзер существует. достаём его идентификатор
		if(!IsSet($Doc['id']))
			return new gException('USER_ID_MISSING','Отсутствует идентификатор созданного пользователя');
		#-------------------------------------------------------------------------------
		$VmUserID = $Doc['id'];
		#-------------------------------------------------------------------------------
		#-------------------------------------------------------------------------------
		# проверяем есть ли у него виртуалки
		$VMs = VmManager5_OVZ_GetVm($Settings,$VPSOrder['Login']);
		#-------------------------------------------------------------------------------
		if(SizeOf($VMs) > 0)
			return new gException('VmManager5_OVZ_Create','Пользователь уже существует, и у него есть хоть одна виртуальная машина');
		#-------------------------------------------------------------------------------
	}else{
		#-------------------------------------------------------------------------------
		Debug(SPrintF('[VmManager5_OVZ_Create]: юзер %s НЕ найден, созадём его',$VPSOrder['Login']));
		#-------------------------------------------------------------------------------
		# предполагаем, что это ошибка проверки, а значит юзер не существует
		# создаём юзера
		$Request = Array(
				'func'			=> 'user.edit',		# Целевая функция
				'sok'			=> 'ok',
				//'allowcreatevm'	=> 'off',		# нет ограничений, нет смысла создавать неограниченных юзеров
				'snapshot_limit'	=> $VPSScheme['snapshot_limit'],
				//'isolimitsize'	=> $VPSScheme['isolimitsize'],
				//'isolimitnum'		=> $VPSScheme['isolimitnum'],
				'name'			=> $VPSOrder['Login'],
				'passwd'		=> $VPSOrder['Password'],
				'confirm'		=> $VPSOrder['Password'],
				);
		#-------------------------------------------------------------------------------
		$XML = VmManager5_OVZ_Request($Settings,$Request);
		#-------------------------------------------------------------------------------
		$Doc = $XML['doc'];
		#-------------------------------------------------------------------------------
		if(IsSet($Doc['error']))
			return new gException('USER_ACCOUNT_CREATE_ERROR','Не удалось создать пользователя для виртуального сервера');
		#-------------------------------------------------------------------------------
		if(!IsSet($Doc['id']))
			return new gException('USER_ID_MISSING','Отсутствует идентификатор созданного пользователя');
		#-------------------------------------------------------------------------------
		$VmUserID = $Doc['id'];
		#-------------------------------------------------------------------------------
	}
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	# достаём список шаблонов VM, нам нужен числовой идентфикатор указанного шаблона
	$Request = Array('func'=>'preset');
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request,'elem');
	#-------------------------------------------------------------------------------
	$Doc = $XML['doc'];
	if(IsSet($Doc['error']))
		return new gException('VmManager5_OVZ_Create','Не удалось получить список шаблонов VM');
	#------------------------------------------------------------------------------
	foreach($Doc as $Preset){
		#------------------------------------------------------------------------------
		if(!IsSet($Preset['id']))
			continue;
		#------------------------------------------------------------------------------
		if($Preset['name'] == $VPSScheme['preset'])
			$VmPresetID = $Preset['id'];
		#------------------------------------------------------------------------------
	}
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	if(!IsSet($VmPresetID))
		Debug(SPrintF('[VmManager5_OVZ_Create]: шаблон "%s" не найден в шаблонах на OVZmgr, виртуалка будет создана без шаблона',$VPSScheme['preset']));
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	# создаём виртуалку
	$Request = Array(
			'func'			=> 'vm.edit',					# Целевая функция
			'sok'			=> 'ok',
			'hostnode'		=> $VPSScheme['Node'],				// нода кластера
			'blkiotune'		=> Ceil($VPSScheme['blkiotune']),		# "вес" дисковых операций
			'password'		=> $VPSOrder['Password'],
			'confirm'		=> $VPSOrder['Password'],
			'cpufreq'		=> Ceil($VPSScheme['cpu']),			# "вес" процессорных операций
			'domain'		=> $VPSOrder['Domain'],				# для обратной зоны
			'family'		=> 'ipv4',					# пока IPv6 всё ещё теория
			'chratein'		=> SPrintF('%u',$VPSScheme['chrate'] * 1024),	# в тарифе в мегабитах
			'chrateout'		=> SPrintF('%u',$VPSScheme['chrate'] * 1024),	# в тарифе в мегабитах
			#'ip'			=> '1.2.3.4',
			'iptype'		=> 'public',					# машина имеет доступ в инет
			'mem'			=> Ceil($VPSScheme['mem']),			# рама
			'name'			=> $VPSOrder['Login'],
			'user'			=> $VmUserID,
			'cpu'			=> $VPSScheme['ncpu'],				# число процессоров
			'ostemplate'		=> StrToLower(Trim($VPSOrder['DiskTemplate'])),
			'hdd'			=> $VPSScheme['disklimit'],
			'swapratio'		=> 10,						// в доке параметр есть, в интрефесе вынесен в шаблон
			'numproc'		=> $VPSScheme['proc'],				// процессов
			'numfile'		=> $VPSScheme['maxdesc'],			// файловых дескрипторов
			'fstype'		=> $VPSScheme['fstype'],			// тип файловой системы
			'enable_tun'		=> ($VPSScheme['IsTun'])?'on':'off'		// разрешение использовать туннельный адаптер
			//'iolimit'		=> ?						// в доке параметр есть, в интерфейсе - не нашёл
			//'iopslimit'		=> ?						// в доке параметр есть, в интерфейсе - не нашёл
			);
	#-------------------------------------------------------------------------------
	if(IsSet($VmPresetID))
		$Request['preset'] = $VmPresetID;
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request);
	#-------------------------------------------------------------------------------
	$Doc = $XML['doc'];
	#-------------------------------------------------------------------------------
	if(IsSet($Doc['error']))
		return new gException('ACCOUNT_CREATE_ERROR','Не удалось создать виртуальный сервер');
	#-------------------------------------------------------------------------------
        if(!IsSet($Doc['id']))
		return new gException('VM_ID_MISSING','Отсутствует идентификатор созданной виртуальной машины');
	#-------------------------------------------------------------------------------
	$VmID = $Doc['id'];
	#-------------------------------------------------------------------------------
	// были проблемы при попытке получить информацию сразу после создания старта. думаю, стоит подождать с минуту.
	Sleep(60);	// TODO может стоит время вынести в конфиг?
	#-------------------------------------------------------------------------------
	$Request = Array(
			'func'			=> 'vm.edit',		# Целевая функция
			'elid'			=> $VmID,
			);
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request);
	#-------------------------------------------------------------------------------
	$Doc = $XML['doc'];
	#-------------------------------------------------------------------------------
	if(IsSet($Doc['error']))
		return new gException('GET_VM_INFO_ERROR','Не удалось получить информацию о виртуальном сервере');
	#-------------------------------------------------------------------------------
        if(!IsSet($Doc['ip']))
		return new gException('VM_IP_MISSING','Отсутствует IP созданной виртуальной машины');
	#-------------------------------------------------------------------------------
	Debug(SPrintF('[system/libs/VmManager5_OVZ]: VPS order created with IP = %s',$Doc['ip']));
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	return Array('ID'=>$VPSOrder['ID'],'IP'=>$Doc['ip']);
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
}

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
function VmManager5_OVZ_Active($Settings,$Login){
	/******************************************************************************/
	$__args_types = Array('array','string');
	#-------------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/******************************************************************************/
	$VMs = VmManager5_OVZ_GetVm($Settings,$Login);
	#-------------------------------------------------------------------------------
	if(SizeOf($VMs) < 1)
		return new gException('VmManager5_OVZ_Active','Не удалось получить список виртуальных машин пользователя');
	#-------------------------------------------------------------------------------
	foreach($VMs as $VM){
		#-------------------------------------------------------------------------------
		#Debug(SPrintF('[system/libs/VmManager5_OVZ]: VM = %s',print_r($VM,true)));
		if(!IsSet($VM['id']))
			continue;
		#-------------------------------------------------------------------------------
		$Request = Array('func'=>'vm.start','elid'=>$VM['id']);
		#-------------------------------------------------------------------------------
		$XML = VmManager5_OVZ_Request($Settings,$Request);
		#-------------------------------------------------------------------------------
		$Doc = $XML['doc'];
		#-----------------------------------------------------------------------------
		if(IsSet($Doc['error']))
			return new gException('VM_ACTIVATE_ERROR','Не удалось включить виртуальный сервер');
		#-------------------------------------------------------------------------------
	}
	#-------------------------------------------------------------------------------
	return TRUE;
	#-------------------------------------------------------------------------------
}

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
function VmManager5_OVZ_Suspend($Settings,$Login,$VPSScheme){
	/******************************************************************************/
	$__args_types = Array('array','string','array');
	#-------------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/******************************************************************************/
	#------------------------------------------------------------------------------
	$VMs = VmManager5_OVZ_GetVm($Settings,$Login);
	#-------------------------------------------------------------------------------
	if(SizeOf($VMs) < 1)
		return new gException('VmManager5_OVZ_Suspend','Не удалось получить список виртуальных машин пользователя');
	#-------------------------------------------------------------------------------
	foreach($VMs as $VM){
		#-------------------------------------------------------------------------------
		#Debug(SPrintF('[system/libs/VmManager5_OVZ]: VM = %s',print_r($VM,true)));
		if(!IsSet($VM['id']))
			continue;
		#-------------------------------------------------------------------------------
		$Request = Array('func'=>'vm.stop','elid'=>$VM['id']);
		#-------------------------------------------------------------------------------
		$XML = VmManager5_OVZ_Request($Settings,$Request);
		#-------------------------------------------------------------------------------
		$Doc = $XML['doc'];
		#-----------------------------------------------------------------------------
		if(IsSet($Doc['error']))
			return new gException('VM_SUSPEND_ERROR','Не удалось выключить виртуальный сервер');
		#-------------------------------------------------------------------------------
	}
	#-------------------------------------------------------------------------------
	return TRUE;
	#-------------------------------------------------------------------------------
}

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
function VmManager5_OVZ_Delete($Settings,$Login){
	/******************************************************************************/
	$__args_types = Array('array','string','array');
	#-------------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/******************************************************************************/
	# проверяем, возможно такого уже и нету
	$Request = Array('func'=>'user');
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request,'elem');
	#-------------------------------------------------------------------------------
	$Doc = $XML['doc'];
	if(IsSet($Doc['error']))
		return new gException('VmManager5_OVZ_Delete','Не удалось получить список пользователей');
	#------------------------------------------------------------------------------
	foreach($Doc as $User){
		#------------------------------------------------------------------------------
		if(!IsSet($User['id']))
			continue;
		#------------------------------------------------------------------------------
		if($User['name'] == $Login)
			$VmUserID = $User['id'];
		#------------------------------------------------------------------------------
	}
	#-------------------------------------------------------------------------------
	if(!IsSet($VmUserID)){
		#-------------------------------------------------------------------------------
		Debug(SPrintF('[VmManager5_OVZ_Delete]: пользователь %s уже удалён ',$Login));
		#-------------------------------------------------------------------------------
		return TRUE;
		#-------------------------------------------------------------------------------
	}
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	$VMs = VmManager5_OVZ_GetVm($Settings,$Login);
	#-------------------------------------------------------------------------------
	// TODO а может их уже удалили, был сбой просто?
	//if(SizeOf($VMs) < 1)
	//	return new gException('VmManager5_OVZ_Delete','Не удалось получить список виртуальных машин пользователя');
	#-------------------------------------------------------------------------------
	foreach($VMs as $VM){
		#-------------------------------------------------------------------------------
		#Debug(SPrintF('[VmManager5_OVZ_Delete]: VM = %s',print_r($VM,true)));
		if(!IsSet($VM['id']))
			continue;
		#-------------------------------------------------------------------------------
		$Request = Array('func'=>'vm.delete','confirm'=>'on','elid'=>$VM['id']);
		#-------------------------------------------------------------------------------
		$XML = VmManager5_OVZ_Request($Settings,$Request);
		#-------------------------------------------------------------------------------
		$Doc = $XML['doc'];
		#-----------------------------------------------------------------------------
		if(IsSet($Doc['error']))
			return new gException('VM_DELETE_ERROR','Не удалось удалить виртуальный сервер');
		#-------------------------------------------------------------------------------
	}
	#------------------------------------------------------------------------------
	#------------------------------------------------------------------------------
	# грохаем самого юзера
	$Request = Array('func'=>'user.delete','elid'=>$VmUserID);
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request);
	#-------------------------------------------------------------------------------
	$Doc = $XML['doc'];
	#-----------------------------------------------------------------------------
	if(IsSet($Doc['error']))
		return new gException('USER_DELETE_ERROR','Не удалось удалить пользователя виртуального сервера');
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	return TRUE;
	#-------------------------------------------------------------------------------
	#------------------------------------------------------------------------------
}

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
function VmManager5_OVZ_Scheme_Change($Settings,$VPSOrder,$VPSScheme){
	/******************************************************************************/
	$__args_types = Array('array','array','array');
	#-------------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/******************************************************************************/
	# достаём всех пользователей, перебираем и ищем нужного
	$Request = Array('func'=>'user');
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request,'elem');
	#-------------------------------------------------------------------------------
	$Doc = $XML['doc'];
	if(IsSet($Doc['error']))
		return new gException('VmManager5_OVZ_Scheme_Change','Не удалось получить список пользователей');
	#-------------------------------------------------------------------------------
	foreach($Doc as $User){
		#-------------------------------------------------------------------------------
		if(!IsSet($User['id']))
			continue;
		#-------------------------------------------------------------------------------
		if(!IsSet($User['name']))
			continue;
		#-------------------------------------------------------------------------------
		if($User['name'] == $VPSOrder['Login'])
			$UserID = $User['id'];
		#-------------------------------------------------------------------------------

	}
	#-------------------------------------------------------------------------------
	if(!IsSet($UserID))
		return new gException('VmManager5_OVZ_Scheme_Change',SPrintF('Не удалось найти полльзователя "%s"',$VPSOrder['Login']));
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	# меняем параметры пользователя
	# создаём юзера
	$Request = Array(
			'func'			=> 'user.edit',		# Целевая функция
			'sok'			=> 'ok',
			'allowcreatevm'		=> 'off',		# нет ограничений, нет смысла создавать неограниченных юзеров
			'snapshot_limit'	=> $VPSScheme['snapshot_limit'],
			'isolimitsize'		=> $VPSScheme['isolimitsize'],
			'isolimitnum'		=> $VPSScheme['isolimitnum'],
			'name'			=> $VPSOrder['Login'],
			'passwd'		=> $VPSOrder['Password'],
			'confirm'		=> $VPSOrder['Password'],
			'elid'			=> $UserID
			);
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request);
	#-------------------------------------------------------------------------------
	$Doc = $XML['doc'];
	#-------------------------------------------------------------------------------
	if(IsSet($Doc['error']))
		return new gException('USER_CHANGE_ERROR','Не удалось изменить пользователя');
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	$VMs = VmManager5_OVZ_GetVm($Settings,$VPSOrder['Login']);
	#-------------------------------------------------------------------------------
	if(SizeOf($VMs) < 1)
		return new gException('VmManager5_OVZ_Scheme_Change','Не удалось получить список виртуальных машин пользователя');
	#-------------------------------------------------------------------------------
	foreach($VMs as $VM){
		#-------------------------------------------------------------------------------
		#Debug(SPrintF('[system/libs/VmManager5_OVZ]: VM = %s',print_r($VM,true)));
		if(!IsSet($VM['id']))
			continue;
		#-------------------------------------------------------------------------------
		#-------------------------------------------------------------------------------
		$Request = Array(
				'func'			=> 'vm.edit',					# Целевая функция
				'sok'			=> 'ok',
				'blkiotune'		=> Ceil($VPSScheme['blkiotune']),		# "вес" дисковых операций
				'password'		=> $VPSOrder['Password'],
				'confirm'		=> $VPSOrder['Password'],
				'cpufreq'		=> Ceil($VPSScheme['cpu']),			# "вес" процессорных операций
				'domain'		=> $VPSOrder['Domain'],				# для обратной зоны
				'chratein'		=> SPrintF('%u',$VPSScheme['chrate'] * 1024),	# в тарифе в мегабитах
				'chrateout'		=> SPrintF('%u',$VPSScheme['chrate'] * 1024),	# в тарифе в мегабитах
				'mem'			=> Ceil($VPSScheme['mem']),			# рама
				'cpu'			=> $VPSScheme['ncpu'],				# число процессоров
				'hdd'			=> $VPSScheme['disklimit'],
				'swapratio'		=> 10,						// в доке параметр есть, в интрефесе вынесен в шаблон
				'numproc'		=> $VPSScheme['proc'],				// процессов
				'numfile'		=> $VPSScheme['maxdesc'],			// файловых дескрипторов
				'enable_tun'		=> ($VPSScheme['IsTun'])?'on':'off',		// разрешение использовать туннельный адаптер
				//'iolimit'		=> ?						// в доке параметр есть, в интерфейсе - не нашёл
				//'iopslimit'		=> ?						// в доке параметр есть, в интерфейсе - не нашёл
				'elid'			=> $VM['id'],
				);
		#-------------------------------------------------------------------------------
		$XML = VmManager5_OVZ_Request($Settings,$Request);
		#-------------------------------------------------------------------------------
		$Doc = $XML['doc'];
		#-------------------------------------------------------------------------------
		if(IsSet($Doc['error']))
			return new gException('SCHEME_CHANGE_ERROR','Не удалось изменить тарифный план для заказа VPS');
		#-------------------------------------------------------------------------------
	}
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	return TRUE;
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
}

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
function VmManager5_OVZ_Password_Change($Settings,$Login,$Password,$Params){
	/******************************************************************************/
	$__args_types = Array('array','string','string','array');
	#-------------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/******************************************************************************/
	#-------------------------------------------------------------------------------
	$Request = Array(
			'func'		=> 'usrparam',
	                'name'		=> $Login,
			'passwd'	=> $Password,
			'confirm'	=> $Password,
			'atype'		=> 'atany',
			'sok'		=> 'ok',
			'su'		=> $Login,
			'setgeoip'	=> 'off',
			'secureip'	=> 'off',
			'vk_status'	=> 'off',
			'fb_status'	=> 'off',
			'gl_status'	=> 'off',
	);
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request);
	#-------------------------------------------------------------------------------
	$Doc = $XML['doc'];
	#-------------------------------------------------------------------------------
	if(IsSet($Doc['error']))
		return new gException('PASSWORD_CHANGE_ERROR','Не удалось изменить пароль для пользователя виртуального сервера');
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	$VMs = VmManager5_OVZ_GetVm($Settings,$Login);
	#-------------------------------------------------------------------------------
	if(SizeOf($VMs) < 1)
		return new gException('VmManager5_OVZ_Password_Change','Не удалось получить список виртуальных машин пользователя');
	#-------------------------------------------------------------------------------
	foreach($VMs as $VM){
		#-------------------------------------------------------------------------------
		#Debug(SPrintF('[VmManager5_OVZ_Password_Change]: VM = %s',print_r($VM,true)));
		if(!IsSet($VM['id']))
			continue;
		#-------------------------------------------------------------------------------
		# http://forum.ispsystem.com/ru/showthread.php?t=27057
		if(!IsSet($VM['chpass']))
			continue;
		#-------------------------------------------------------------------------------
		if($VM['chpass'] != 'on')
			continue;
		#-------------------------------------------------------------------------------
		$Request = Array(
				'func'			=> 'vm.chpasswd',	# Целевая функция
				'sok'			=> 'ok',
				'elid'			=> $VM['id'],
				'password'		=> $Password,
				'confirm'		=> $Password,
				);
		#-------------------------------------------------------------------------------
		$XML = VmManager5_OVZ_Request($Settings,$Request);
		#-------------------------------------------------------------------------------
		$Doc = $XML['doc'];
		#-------------------------------------------------------------------------------
		# не для все виртуалок можно так менять пасс
		if(IsSet($Doc['error']))
			Debug(SPrintF('[system/libs/VmManager5_OVZ.php]: не удалось изменить пароль, возможно функция не поддерживается'));
		#	return new gException('PASSWORD_CHANGE_ERROR','Не удалось изменить пароль для заказа VPS');
		#-------------------------------------------------------------------------------
	}
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	return TRUE;
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
}

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
# added by lissyara 2011-08-09 in 09:55 MSK
function VmManager5_OVZ_AddIP($Settings,$Login,$ID,$Domain,$IP,$AddressType){
	/****************************************************************************/
        $__args_types = Array('array','string','string','string','string','string');
        $__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
        #Debug("ExtraIP order ID = " . $ID);
	/****************************************************************************/
	# достаём список виртуалок
	$VMs = VmManager5_OVZ_GetVm($Settings,$Login);
	#-------------------------------------------------------------------------------
	if(SizeOf($VMs) < 1)
		return new gException('VmManager5_OVZ_AddIP','Не удалось получить список виртуальных машин пользователя');
	#-------------------------------------------------------------------------------
	if(SizeOf($VMs) > 1)
		return new gException('VmManager5_OVZ_AddIP','У пользователя более одной виртуальной машины, невозможно добавить IP адрес');
	#-------------------------------------------------------------------------------
	foreach($VMs as $VM){
		#-------------------------------------------------------------------------------
		#Debug(SPrintF('[system/libs/VmManager5_OVZ]: VM = %s',print_r($VM,true)));
		if(!IsSet($VM['id']))
			continue;
		#-----------------------------------------------------------------------------
        	$Request = Array(
				'func'			=> 'iplist.edit',
				'domain'		=> $Domain,
				'family'		=> 'ipv4',
				#'ip'			=> '',
				'iptype'		=> 'public',
				'plid'			=> $VM['id'],
				'sok'			=> 'ok',
				#'elid'			=> '',
        	);
        	#Debug(var_export($Settings, true));
		#-------------------------------------------------------------------------------
		$XML = VmManager5_OVZ_Request($Settings,$Request);
        	#-----------------------------------------------------------------------------
        	$Doc = $XML['doc'];
        	#-----------------------------------------------------------------------------
		if(IsSet($Doc['error']))
			return new gException('AddIP_ERROR','Не удалось добавить IP для виртуального сервера');
		#-----------------------------------------------------------------------------
		Debug("[system/libs/VmManager5_OVZ]: to VPS added IP = " . $Doc['ip']);
	        #-----------------------------------------------------------------------------
	}
	#-----------------------------------------------------------------------------
	#-----------------------------------------------------------------------------
	return Array('ID'=>$ID,'IP'=>$Doc['ip']);
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
}

# added by lissyara 2011-08-09 in 13:03 MSK
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
function VmManager5_OVZ_DeleteIP($Settings,$ExtraIP){
	/******************************************************************************/
        $__args_types = Array('array','string');
	#-------------------------------------------------------------------------------
        $__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
        #Debug("ExtraIP order ID = " . $ID);
	/******************************************************************************/
	# достаём список виртуалок
	$VMs = VmManager5_OVZ_GetVm($Settings);
	#-------------------------------------------------------------------------------
	if(SizeOf($VMs) < 1)
		return new gException('VmManager5_OVZ_DeleteIP','Не удалось получить список виртуальных машин');
	#-------------------------------------------------------------------------------
	foreach($VMs as $VM){
		#-------------------------------------------------------------------------------
		#Debug(SPrintF('[system/libs/VmManager5_OVZ]: VM = %s',print_r($VM,true)));
		if(!IsSet($VM['id']))
			continue;
		#-------------------------------------------------------------------------------
		# достаём список адресов машинки
		$Request = Array('func'=>'iplist','elid'=>$VM['id']);
		#-------------------------------------------------------------------------------
		$XML = VmManager5_OVZ_Request($Settings,$Request,'elem');
		#-------------------------------------------------------------------------------
		$Doc = $XML['doc'];
		if(IsSet($Doc['error']))
			return new gException('VmManager5_OVZ_DeleteIP','Не удалось получить список IP адресов машины');
		#-------------------------------------------------------------------------------
		foreach($Doc as $IP){
			#-------------------------------------------------------------------------------
			if(!IsSet($IP['id']))
				continue;
			#-------------------------------------------------------------------------------
			Debug(SPrintF('[system/libs/VmManager5_OVZ]: VM[id] = %s; IP[id] = %s; IP[ip] = %s',$VM['id'],$IP['id'],$IP['ip']));
			#-------------------------------------------------------------------------------
			if($IP['ip'] != $ExtraIP)
				continue;
			#-------------------------------------------------------------------------------
			# удаляем
			$Request = Array('func'=>'iplist.delete','plid'=>$VM['id'],'elid'=>$IP['id']);
			#-------------------------------------------------------------------------------
			$XML = VmManager5_OVZ_Request($Settings,$Request,'elem');
			#-------------------------------------------------------------------------------
			if(IsSet($XML['doc']['error']))
				return new gException('VmManager5_OVZ_DeleteIP','Не удалось получить список виртуальных машин');
			#-------------------------------------------------------------------------------
			return TRUE;
			#-------------------------------------------------------------------------------
		}
		#-------------------------------------------------------------------------------
	}
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	Debug(SPrintF('[system/libs/VmManager5_OVZ]: IP адрес (%s) не обнаружен ни на одной виртуальной машине',$ExtraIP));
        #------------------------------------------------------------------------------
	#------------------------------------------------------------------------------
	return TRUE;
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
}

# added by lissyara 2011-10-07 in 10:28 MSK
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
function VmManager5_OVZ_MainUsage($Settings){
	/******************************************************************************/
        $__args_types = Array('array');
        $__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/******************************************************************************/
	# TODO: надо сделать
	return rand(1,10);
	#-------------------------------------------------------------------------------
        $Request = Array(
                'func'          => 'mainusage',
                'sok'           => 'ok'
        );
        #Debug(var_export($Settings, true));
	#-----------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request);
        #-----------------------------------------------------------------------------
        $Doc = $XML['doc'];
        if(IsSet($Doc['error']))
                return new gException('VmManager5_OVZ_MainUsage','Не удалось получить нагрузку сервера');
        #---------------------------------------------------------------------------
        # перебираем, складываем
        $Out = Array(
                        'cpuu'  => 0,
                        'memu'  => 0,
                        'swapu' => 0,
                        'disk0' => 0
                );
        $NumStrings = SizeOf($Doc);
        foreach($Doc as $Usage){
                $Out['cpuu'] = $Out['cpuu'] + $Usage['cpuu'];
                $Out['memu'] = $Out['memu'] + $Usage['memu'];
                $Out['swapu'] = $Out['swapu'] + $Usage['swapu'];
                $Out['disk0'] = $Out['disk0'] + $Usage['disk0'];
        }
        # считаем средние значнеия
        $Out['cpuu'] = $Out['cpuu'] / SizeOf($Doc);
        $Out['memu'] = $Out['memu'] / SizeOf($Doc);
        $Out['swapu'] = $Out['swapu'] / SizeOf($Doc);
        $Out['disk0'] = $Out['disk0'] / SizeOf($Doc);
        
        Debug("[system/libs/VmManager5_OVZ.php]: usage for " . $Settings['Address'] . " is " . $Out['cpuu'] ."/". $Out['memu'] ."/". $Out['swapu'] ."/". $Out['disk0']);
        return ($Out['cpuu'] + $Out['memu'] + $Out['swapu'] + $Out['disk0']);
	#-----------------------------------------------------------------------------
}

# added by lissyara, 2012-02-02 in 21:53 MSK
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
function VmManager5_OVZ_CheckIsActive($Settings,$Login){
	/******************************************************************************/
	$__args_types = Array('array','string');
	#-------------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/******************************************************************************/
	$VMs = VmManager5_OVZ_GetVm($Settings);
	#-------------------------------------------------------------------------------
	if(SizeOf($VMs) < 1)
		return new gException('VmManager5_OVZ_CheckIsActive','Не удалось получить список виртуальных машин');
	#-------------------------------------------------------------------------------
	foreach($VMs as $VM)
		if(IsSet($VM['id']))
			if($VM['name'] == $Login)
				if(IsSet($VM['vmpowered']) && $VM['vmpowered'] == 'off')
					if(IsSet($VM['vmstatus']) && $VM['vmstatus'] == 'admdown')
						return FALSE;
	#-----------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	// машина(-ы?) активна
	#Debug(SPrintF("[system/libs/VmManager5_OVZ]: %s is enabled, disabled not by administrator, or not found",$Login));
	return TRUE;
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
}

# added by lissyara, 2012-02-03 in 09:59 MSK
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
function VmManager5_OVZ_Reboot($Settings,$Login){
	/******************************************************************************/
	$__args_types = Array('array','string');
	#-------------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/******************************************************************************/
	# проверяем - активна ли машина, а то если задизабленную ребутнуть - она включается
	if(!VmManager5_OVZ_CheckIsActive($Settings,$Login)){
		#-------------------------------------------------------------------------------
		return new gException('ACCOUNT_REBOOT_ERROR_IsDisabled','Не удалось перезагрузить виртуальный сервер - он выключен администратором');
		#-------------------------------------------------------------------------------
	}
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	$VMs = VmManager5_OVZ_GetVm($Settings,$Login);
	#-------------------------------------------------------------------------------
	if(SizeOf($VMs) < 1)
		return new gException('VmManager5_OVZ_Reboot','Не удалось получить список виртуальных машин пользователя');
	#-------------------------------------------------------------------------------
	foreach($VMs as $VM){
		#-------------------------------------------------------------------------------
		#Debug(SPrintF('[system/libs/VmManager5_OVZ]: VM = %s',print_r($VM,true)));
		if(!IsSet($VM['id']))
			continue;
		#-------------------------------------------------------------------------------
		#-------------------------------------------------------------------------------
		$Request = Array('func'=>'vm.restart','elid'=>$VM['id']);
		#-------------------------------------------------------------------------------
		$XML = VmManager5_OVZ_Request($Settings,$Request);
		#-------------------------------------------------------------------------------
		$Doc = $XML['doc'];
		#-------------------------------------------------------------------------------
		if(IsSet($Doc['error']))
			return new gException('ACCOUNT_REBOOT_ERROR','Не удалось перезагрузить виртуальный сервер');
		#-------------------------------------------------------------------------------
	}
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	return TRUE;
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
}

# added by lissyara, 2013-05-17 in 09:53 MSK, for JBS-280
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
function VmManager5_OVZ_Get_Users($Settings){
	/****************************************************************************/
	$__args_types = Array('array');
	#-----------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/****************************************************************************/
	$Request = Array('func'=>'user');
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request,'elem');
	#-----------------------------------------------------------------------------
	$Users = $XML['doc'];
	#-----------------------------------------------------------------------------
	if(IsSet($Users['error']))
		return new gException('GET_USERS_ERROR',$Users['error']);
	#-----------------------------------------------------------------------------
	$Result = Array();
	#-----------------------------------------------------------------------------
	foreach($Users as $User){
		#---------------------------------------------------------------------------
		if(!IsSet($User['id']))
			continue;
		#---------------------------------------------------------------------------
		if(!IsSet($User['name']))
			continue;
		#---------------------------------------------------------------------------
		if($User['name'] != $Settings['Login'])
			$Result[] = $User['name'];
		#-----------------------------------------------------------------------------
	}
	#-----------------------------------------------------------------------------
	#-----------------------------------------------------------------------------
	return $Result;
	#-----------------------------------------------------------------------------
}

#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
function VmManager5_OVZ_Get_DiskTemplates($Settings){
	/****************************************************************************/
	$__args_types = Array('array');
	#-----------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/****************************************************************************/
	$Request = Array('func'=>'vm.edit');
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request,Array('попофигу-на-самом-деле'));
	#-----------------------------------------------------------------------------
	$Templates = $XML['doc'];
	//Debug(SPrintF('[VmManager5_OVZ_Get_DiskTemplates]: Templates = %s',print_r($Templates,true)));
	#-----------------------------------------------------------------------------
	if(IsSet($Templates['error']))
		return new gException('GET_TEMPLATES_ERROR',$Templates['error']);
	#-----------------------------------------------------------------------------
	$Result = Array();
	#-----------------------------------------------------------------------------
	// может не быть соединения
	if(!$Templates)
		return $Result;
	#-----------------------------------------------------------------------------
	// это пиздец какой кривой метод. но - другого не знает даже саппорт ИСПсистем
	foreach($Templates as $Keys){
		#-----------------------------------------------------------------------------
		if(Is_Array($Keys)){
			#-----------------------------------------------------------------------------
			foreach($Keys as $Key){
				#-----------------------------------------------------------------------------
				//Debug(SPrintF('[VmManager5_OVZ_Get_DiskTemplates]: Key = %s',print_r($Key,true)));
				// есть ключ + в ключе есть дефис
				if(IsSet($Key['key']) && StrPos($Key['key'],'-')){
					#-----------------------------------------------------------------------------
					Debug(SPrintF('[VmManager5_OVZ_Get_DiskTemplates]: key = %s; IntVal(key) = %s',$Key['key'],IntVal($Key['key'])));
					#-----------------------------------------------------------------------------
					$Result[] = $Key['key'];
					#-----------------------------------------------------------------------------
				}
				#-----------------------------------------------------------------------------
			}
			#-----------------------------------------------------------------------------
		}
		/*
[root@s3 ~]# /usr/local/mgr5/sbin/mgrctl -m vemgr vm.edit out=xml | xmllint --format -



<?xml version="1.0" encoding="UTF-8"?>
<doc lang="en" func="vm.edit" binary="/vemgr" host="http://" themename="orion" features="6f2f82022074b33e6a26c55dac4bacf4" notify="">
  <slist name="user">
    <val key="8">o144262</val>
    <val key="9">o144263</val>
  </slist>
  <slist name="ostemplate">
    <val key="centos-6-x86-minimal">Centos-6.0-x86</val>
    <val key="centos-6-x86_64-minimal">Centos-6.0-x86_64</val>
    <val key="centos-7-x86_64-minimal">Centos-7-x86_64</val>
    <val key="debian-7.0-x86-minimal">Debian-7-x86</val>
    <val key="debian-7.0-x86_64-minimal">Debian-7-x86_64</val>
    <val key="debian-8.0-x86_64-minimal">Debian-8-x86_64-minimal</val>
    <val key="debian-9.0-x86_64-minimal">Debian-9-x86_64-minimal</val>
    <val key="ubuntu-14.04-x86_64-minimal">Ubuntu-14.04-amd64</val>
    <val key="ubuntu-14.04-x86-minimal">Ubuntu-14.04-i386</val>
    <val key="ubuntu-16.04-x86_64">Ubuntu-16.04-x86_64</val>
  </slist>
  <slist name="recipe">
    <val msg="yes" depend="centos-6-x86-minimal" key="null">-- none --</val>
    <val key="ISPsystem__ispmanager.sh" depend="centos-6-x86-minimal">ISPmanager Lite rev.15 [ISPsystem]</val>


		*/
		#-----------------------------------------------------------------------------
		/* вариант кода из VmManager - прямой
		if(!IsSet($Template['id']))
			continue;
		#-----------------------------------------------------------------------------
		if(!IsSet($Template['name']))
			continue;
		#-----------------------------------------------------------------------------
		if(!IsSet($Template['installed']) || $Template['installed'] != 'on')
			continue;
		#-----------------------------------------------------------------------------
		if($Template['restrict'] != 'off')
			continue;
		#-----------------------------------------------------------------------------
		$Result[] = $Template['name'];
		#-----------------------------------------------------------------------------
		*/
	}
	#-----------------------------------------------------------------------------
	#-----------------------------------------------------------------------------
	return $Result;
	#-----------------------------------------------------------------------------
	#-----------------------------------------------------------------------------
}

#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
function VmManager5_OVZ_Get_NodeList($Settings){
	/****************************************************************************/
	$__args_types = Array('array');
	#-----------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/****************************************************************************/
	$Request = Array('func'=>'vmhostnode');
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request,'elem');
	#-----------------------------------------------------------------------------
	$Nodes = $XML['doc'];
	#-----------------------------------------------------------------------------
	if(IsSet($Nodes['error']))
		return new gException('GET_LIST_NODES_ERROR',$Templates['error']);
	#-----------------------------------------------------------------------------
	//Debug(SPrintF('Nodes = %s',print_r($Nodes,true)));
	$Result = Array();
	#-----------------------------------------------------------------------------
	foreach($Nodes as $Node){
		#-----------------------------------------------------------------------------
		#Debug(SPrintF('Node = %s',print_r($Node,true)));
		if(!IsSet($Node['id']))
			continue;
		#-----------------------------------------------------------------------------
		if(!IsSet($Node['name']))
			continue;
		#-----------------------------------------------------------------------------
		if(!IsSet($Node['active']) || $Node['active'] != 'on')
			continue;
		#-----------------------------------------------------------------------------
		#Debug(SPrintF('Node = %s',print_r($Node,true)));
		// если на ноде проблемы, и создание виртуалок невозможно - пропускаем её
		if(IsSet($Node['problem'])){
			#-----------------------------------------------------------------------------
			Debug(SPrintF('[VmManager5_OVZ_Get_NodeList]: нода %s пропущена, на ней проблемы',$Node['name']));
			#-----------------------------------------------------------------------------
			continue;
			#-----------------------------------------------------------------------------
		}
		// рассчитываем использование. тупо %память + %диск
		$Node['DiskMemUsage'] = IntVal($Node['meminfo']) + IntVal($Node['storageinfo']);
		#-----------------------------------------------------------------------------
		$Result[$Node['name']] = $Node;
		#-----------------------------------------------------------------------------
	}
	#-----------------------------------------------------------------------------
	#-----------------------------------------------------------------------------
	// функция сортировки
	if(!Function_Exists('CMP')){
		#-----------------------------------------------------------------------------
		function CMP($a, $b){
			#-----------------------------------------------------------------------------
        		return ($a['DiskMemUsage'] > $b['DiskMemUsage']);
			#-----------------------------------------------------------------------------
		}
		#-----------------------------------------------------------------------------
	}
	#-----------------------------------------------------------------------------
	#-----------------------------------------------------------------------------
	// сортируем ноды по использованю, чем меньше - там первее.
	// удобно - при поиске ноды просто берём первую - и это самая незагруженная
	UASort($Result,'CMP');
	#-----------------------------------------------------------------------------
	#-----------------------------------------------------------------------------
	return $Result;
	#-----------------------------------------------------------------------------
	#-----------------------------------------------------------------------------
}

#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
// added by lissyara, 2019-10-21 in 08:56 MSK
// для реализации процесса миграции между нодами, да и много где используется этот код
function VmManager5_OVZ_GetVm($Settings,$Login = FALSE){
	/******************************************************************************/
	$__args_types = Array('array','string');
	#-------------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/******************************************************************************/
	// массив параметров
	$Request = Array('func'=>'vm');
	#-------------------------------------------------------------------------------
	// если логин задан - машинка(-и?) конкретного юзера, если не задан - список всех машин
	if($Login)
		$Request['su'] = $Login;
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request,'elem');
	#-------------------------------------------------------------------------------
	$Doc = $XML['doc'];
	if(IsSet($Doc['error']))
		return new gException('VmManager5_OVZ_GetVm','Не удалось получить список виртуальных машин');
	#-------------------------------------------------------------------------------
	// выхлопной массив
	$Out = Array();
	#-------------------------------------------------------------------------------
	foreach($Doc as $VM){
		#-------------------------------------------------------------------------------
		#Debug(SPrintF('[system/libs/VmManager5_OVZ]: VM = %s',print_r($VM,true)));
		if(!IsSet($VM['id']))
			continue;
		#-------------------------------------------------------------------------------
		$Out[$VM['id']] = $VM;
		#-------------------------------------------------------------------------------
	}
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	return $Out;
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
}

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
// added by lissyara, 2019-10-22 in 13:41 MSK
// миграция между нодами
function VmManager5_OVZ_VmMigrate($Settings,$ID,$Node){
	/******************************************************************************/
	$__args_types = Array('array','integer','integer');
	#-------------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/******************************************************************************/
	$Request = Array('func'=>'vm.migrate','elid'=>$ID,'hostnode'=>$Node,'live'=>'on','sok'=>'ok');
	#-------------------------------------------------------------------------------
	$XML = VmManager5_OVZ_Request($Settings,$Request,'elem');
	#-------------------------------------------------------------------------------
	$Doc = $XML['doc'];
	if(IsSet($Doc['error']))
		return new gException('VmManager5_OVZ_VmMigrate','Не удалось запустить миграцию витруальной машины');
	#-------------------------------------------------------------------------------
	#Debug(SPrintF('[system/libs/VmManager5_OVZ]: XML = %s',print_r($XML,true)));
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	return TRUE;
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
}




#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
# внутренняя функция
function VmManager5_OVZ_Request($Settings,$Request,$Name = FALSE){
	/******************************************************************************/
	$__args_types = Array('array','array','boolean,string,array');
	#-----------------------------------------------------------------------------
	$__args__ = Func_Get_Args(); Eval(FUNCTION_INIT);
	/******************************************************************************/
	$authinfo = SPrintF('%s:%s',$Settings['Login'],$Settings['Password']);
	#-------------------------------------------------------------------------------
	$HTTP = Array(
			'Address'	=> $Settings['Params']['IP'],
			'Port'		=> $Settings['Port'],
			'Host'		=> $Settings['Address'],
			'Protocol'	=> $Settings['Protocol'],
			'Hidden'	=> $authinfo,
			'IsLogging'	=> $Settings['Params']['IsLogging']
			);
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	$Request['out']		= 'xml';
	$Request['authinfo']	= $authinfo;
	#-------------------------------------------------------------------------------
	$Response = HTTP_Send('/vemgr',$HTTP,Array(),$Request);
	if(Is_Error($Response))
		return ERROR | @Trigger_Error('[VmManager5_OVZ_Request]: не удалось соедениться с сервером');
	#-------------------------------------------------------------------------------
	$Response = Trim($Response['Body']);
	#-------------------------------------------------------------------------------
	$XML = String_XML_Parse($Response);
	if(Is_Exception($XML))
		return new gException('WRONG_SERVER_ANSWER',$Response,$XML);
	#-------------------------------------------------------------------------------
	if($Name){
		#-------------------------------------------------------------------------------
		$XML = $XML->ToArray('elem','slist','val',Array('ostemplate','key'));
		#-------------------------------------------------------------------------------
	}else{
		#-------------------------------------------------------------------------------
		$XML = $XML->ToArray();
		#-------------------------------------------------------------------------------
	}
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
	return $XML;
	#-------------------------------------------------------------------------------
	#-------------------------------------------------------------------------------
}













?>
